// Datei: Serial.c
//
// Serielle Datenbertragung
//
// In Empfangsrichtung wird ein Interrupt mit Ringpuffer benutzt !
// Die Routinen stammen von SDCC und sind eigentlich fr einen
// 8051 Controller gedacht. Geht ohne groe nderungen auch
// mit einem PIC.
//
// Holger Klabunde 
// 11.05.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "protos.h"

//#######################################
//Serielle Schnittstelle einstellen 
//xxxxxBaud ,8 Bit ,kein Parity, 1 Stopbit
//#######################################
void InitUSART()
{
 BRGH=1;

 rcnt=0;
 rpos=0;
 
// SPBRG=129; // (9600 baud @ 20MHz input clock)
 SPBRG=64; // (19200 baud @ 20MHz input clock)
// SPBRG=32; // (38400 baud @ 20MHz input clock)

 SPEN = 1; //  Set_Serial_Pins;

// Das mag CC5x nicht obwohl es definiert ist !
// SYNC = 0; //  Set_Async_Mode;
 TXSTA.4 = 0; //Dann eben so ;)

 TX9 = 0; //  Set_8bit_Tx;
 RX9 = 0; //  Set_8bit_Rx;
 CREN = 1; //  Enable_Rx;
 TXEN = 1; //  Enable_Tx;

 RCIE=1;   // Rx Interrupt an
}

//#############################
//Ein Datenbyte empfangen
//bzw. aus dem Ringpuffer holen
//#############################
unsigned char Receive()
{
 unsigned char c;

 while(!rcnt);   /* wait for character */

 RCIE=0;   //Disable Rx Interrupt

 rcnt--;   //ein Byte aus dem Puffer geholt
 c = rbuf [rpos++];
 if (rpos >= RBUFLEN) rpos = 0; //Ringzhler neu setzen

 RCIE=1;   //Enable Rx Interrupt

 return (c);
}

//######################
//Ein Datenbyte senden
//######################
void Transmit(unsigned char dat)
{
 while(!TXIF);   // Loop till TXREG empty, WDT off !

 TXREG = dat; // Send data
}
